<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Unit Conversion and Dimensional Analysis Library: units::traits Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Unit Conversion and Dimensional Analysis Library
   &#160;<span id="projectnumber">2.3.0</span>
   </div>
   <div id="projectbrief">A compile-time c++14 unit conversion library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespaceunits.html">units</a></li><li class="navelem"><a class="el" href="namespaceunits_1_1traits.html">traits</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#typedef-members">Typedefs</a>  </div>
  <div class="headertitle">
<div class="title">units::traits Namespace Reference<div class="ingroups"><a class="el" href="group___type_traits.html">Type Traits</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>namespace representing type traits which can access the properties of types provided by the units library.  
<a href="namespaceunits_1_1traits.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1has__decibel__scale.html">has_decibel_scale</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which tests whether a type is inherited from a decibel scale.  <a href="structunits_1_1traits_1_1has__decibel__scale.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1has__linear__scale.html">has_linear_scale</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which tests whether a type is inherited from a linear scale.  <a href="structunits_1_1traits_1_1has__linear__scale.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__acceleration__unit.html">is_acceleration_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__angle__unit.html">is_angle_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__angular__velocity__unit.html">is_angular_velocity_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__area__unit.html">is_area_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__base__unit.html">is_base_unit</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which tests if a class is a <code><a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a></code> type.  <a href="structunits_1_1traits_1_1is__base__unit.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__capacitance__unit.html">is_capacitance_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__charge__unit.html">is_charge_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__concentration__unit.html">is_concentration_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__conductance__unit.html">is_conductance_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__convertible__unit.html">is_convertible_unit</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which checks whether two units can be converted to each other.  <a href="structunits_1_1traits_1_1is__convertible__unit.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__convertible__unit__t.html">is_convertible_unit_t</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which tests whether two container types derived from <code><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a></code> are convertible to each other.  <a href="structunits_1_1traits_1_1is__convertible__unit__t.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__current__unit.html">is_current_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__data__transfer__rate__unit.html">is_data_transfer_rate_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__data__unit.html">is_data_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__density__unit.html">is_density_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__dimensionless__unit.html">is_dimensionless_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__energy__unit.html">is_energy_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__force__unit.html">is_force_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__frequency__unit.html">is_frequency_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__illuminance__unit.html">is_illuminance_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__impedance__unit.html">is_impedance_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__inductance__unit.html">is_inductance_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__length__unit.html">is_length_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__luminous__flux__unit.html">is_luminous_flux_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__luminous__intensity__unit.html">is_luminous_intensity_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__magnetic__field__strength__unit.html">is_magnetic_field_strength_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__magnetic__flux__unit.html">is_magnetic_flux_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__mass__unit.html">is_mass_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__nonlinear__scale.html">is_nonlinear_scale</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which tests that <code>class T</code> meets the requirements for a non-linear scale.  <a href="structunits_1_1traits_1_1is__nonlinear__scale.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__power__unit.html">is_power_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__pressure__unit.html">is_pressure_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__radioactivity__unit.html">is_radioactivity_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__ratio.html">is_ratio</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait that tests whether a type represents a std::ratio.  <a href="structunits_1_1traits_1_1is__ratio.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__same__scale.html">is_same_scale</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which tests whether two types has the same non-linear scale.  <a href="structunits_1_1traits_1_1is__same__scale.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__scalar__unit.html">is_scalar_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__solid__angle__unit.html">is_solid_angle_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__substance__unit.html">is_substance_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__temperature__unit.html">is_temperature_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__time__unit.html">is_time_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__torque__unit.html">is_torque_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__unit.html">is_unit</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Traits which tests if a class is a <code>unit</code>  <a href="structunits_1_1traits_1_1is__unit.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__unit__t.html">is_unit_t</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Traits which tests if a class is a <code>unit</code>  <a href="structunits_1_1traits_1_1is__unit__t.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__unit__value__t.html">is_unit_value_t</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which tests whether a type is a <a class="el" href="structunits_1_1unit__value__t.html" title="Stores a rational unit value as a compile-time constant.">unit_value_t</a> representing the given unit type.  <a href="structunits_1_1traits_1_1is__unit__value__t.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__unit__value__t__category.html">is_unit_value_t_category</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which tests whether type T is a <a class="el" href="structunits_1_1unit__value__t.html" title="Stores a rational unit value as a compile-time constant.">unit_value_t</a> with a unit type in the given category.  <a href="structunits_1_1traits_1_1is__unit__value__t__category.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__velocity__unit.html">is_velocity_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__voltage__unit.html">is_voltage_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1traits_1_1is__volume__unit.html">is_volume_unit</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:ae7756e0f6e8322f5c6150be2b871e544"><td class="memTemplParams" colspan="2">template&lt;class U &gt; </td></tr>
<tr class="memitem:ae7756e0f6e8322f5c6150be2b871e544"><td class="memTemplItemLeft" align="right" valign="top">using&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceunits_1_1traits.html#ae7756e0f6e8322f5c6150be2b871e544">base_unit_of</a> = typename units::detail::base_unit_of_impl&lt; U &gt;::type</td></tr>
<tr class="memdesc:ae7756e0f6e8322f5c6150be2b871e544"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trait which returns the <code><a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a></code> type that a unit is originally derived from.  <a href="namespaceunits_1_1traits.html#ae7756e0f6e8322f5c6150be2b871e544">More...</a><br /></td></tr>
<tr class="separator:ae7756e0f6e8322f5c6150be2b871e544"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>namespace representing type traits which can access the properties of types provided by the units library. </p>
<p>Trait which tests whether a type represents a unit of <a class="el" href="namespaceunits_1_1data__transfer__rate.html" title="namespace for unit types and containers representing data values">data_transfer_rate</a>.</p>
<p>Trait which tests whether a type represents a unit of data.</p>
<p>Trait which tests whether a type represents a unit of concentration.</p>
<p>Trait which tests whether a type represents a unit of density.</p>
<p>Trait which tests whether a type represents a unit of volume.</p>
<p>Trait which tests whether a type represents a unit of area.</p>
<p>Trait which tests whether a type represents a unit of torque.</p>
<p>Trait which tests whether a type represents a unit of radioactivity.</p>
<p>Trait which tests whether a type represents a unit of illuminance.</p>
<p>Trait which tests whether a type represents a unit of <a class="el" href="namespaceunits_1_1luminous__flux.html" title="namespace for unit types and containers representing luminous_flux values">luminous_flux</a>.</p>
<p>Trait which tests whether a type represents a unit of inductance.</p>
<p>Trait which tests whether a type represents a unit of <a class="el" href="namespaceunits_1_1magnetic__field__strength.html" title="namespace for unit types and containers representing magnetic_field_strength values">magnetic_field_strength</a>.</p>
<p>Trait which tests whether a type represents a unit of <a class="el" href="namespaceunits_1_1magnetic__flux.html" title="namespace for unit types and containers representing magnetic_flux values">magnetic_flux</a>.</p>
<p>Trait which tests whether a type represents a unit of conductance.</p>
<p>Trait which tests whether a type represents a unit of impedance.</p>
<p>Trait which tests whether a type represents a unit of capacitance.</p>
<p>Trait which tests whether a type represents a unit of voltage.</p>
<p>Trait which tests whether a type represents a unit of power.</p>
<p>Trait which tests whether a type represents a unit of energy.</p>
<p>Trait which tests whether a type represents a unit of charge.</p>
<p>Trait which tests whether a type represents a unit of pressure.</p>
<p>Trait which tests whether a type represents a unit of force.</p>
<p>Trait which tests whether a type represents a unit of acceleration.</p>
<p>Trait which tests whether a type represents a unit of <a class="el" href="namespaceunits_1_1angular__velocity.html" title="namespace for unit types and containers representing angular velocity values">angular_velocity</a>.</p>
<p>Trait which tests whether a type represents a unit of velocity.</p>
<p>Trait which tests whether a type represents a unit of frequency.</p>
<p>Trait which tests whether a type represents a unit of <a class="el" href="namespaceunits_1_1solid__angle.html" title="namespace for unit types and containers representing solid_angle values">solid_angle</a>.</p>
<p>Trait which tests whether a type represents a unit of <a class="el" href="namespaceunits_1_1luminous__intensity.html" title="namespace for unit types and containers representing luminous_intensity values">luminous_intensity</a>.</p>
<p>Trait which tests whether a type represents a unit of substance.</p>
<p>Trait which tests whether a type represents a unit of temperature.</p>
<p>Trait which tests whether a type represents a unit of current.</p>
<p>Trait which tests whether a type represents a unit of angle.</p>
<p>Trait which tests whether a type represents a unit of time.</p>
<p>Trait which tests whether a type represents a unit of mass.</p>
<p>Trait which tests whether a type represents a unit of length.</p>
<p>Trait which tests whether a type represents a unit of dimensionless.</p>
<p>Trait which tests whether a type represents a unit of scalar.</p>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__scalar__unit.html">is_scalar_unit</a>&lt;T&gt;::value</code> to test the unit represents a scalar quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__dimensionless__unit.html">is_dimensionless_unit</a>&lt;T&gt;::value</code> to test the unit represents a dimensionless quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__length__unit.html">is_length_unit</a>&lt;T&gt;::value</code> to test the unit represents a length quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__mass__unit.html">is_mass_unit</a>&lt;T&gt;::value</code> to test the unit represents a mass quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__time__unit.html">is_time_unit</a>&lt;T&gt;::value</code> to test the unit represents a time quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__angle__unit.html">is_angle_unit</a>&lt;T&gt;::value</code> to test the unit represents a angle quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__current__unit.html">is_current_unit</a>&lt;T&gt;::value</code> to test the unit represents a current quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__temperature__unit.html">is_temperature_unit</a>&lt;T&gt;::value</code> to test the unit represents a temperature quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__substance__unit.html">is_substance_unit</a>&lt;T&gt;::value</code> to test the unit represents a substance quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__luminous__intensity__unit.html">is_luminous_intensity_unit</a>&lt;T&gt;::value</code> to test the unit represents a <a class="el" href="namespaceunits_1_1luminous__intensity.html" title="namespace for unit types and containers representing luminous_intensity values">luminous_intensity</a> quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__solid__angle__unit.html">is_solid_angle_unit</a>&lt;T&gt;::value</code> to test the unit represents a <a class="el" href="namespaceunits_1_1solid__angle.html" title="namespace for unit types and containers representing solid_angle values">solid_angle</a> quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__frequency__unit.html">is_frequency_unit</a>&lt;T&gt;::value</code> to test the unit represents a frequency quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__velocity__unit.html">is_velocity_unit</a>&lt;T&gt;::value</code> to test the unit represents a velocity quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__angular__velocity__unit.html">is_angular_velocity_unit</a>&lt;T&gt;::value</code> to test the unit represents a <a class="el" href="namespaceunits_1_1angular__velocity.html" title="namespace for unit types and containers representing angular velocity values">angular_velocity</a> quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__acceleration__unit.html">is_acceleration_unit</a>&lt;T&gt;::value</code> to test the unit represents a acceleration quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__force__unit.html">is_force_unit</a>&lt;T&gt;::value</code> to test the unit represents a force quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__pressure__unit.html">is_pressure_unit</a>&lt;T&gt;::value</code> to test the unit represents a pressure quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__charge__unit.html">is_charge_unit</a>&lt;T&gt;::value</code> to test the unit represents a charge quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__energy__unit.html">is_energy_unit</a>&lt;T&gt;::value</code> to test the unit represents a energy quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__power__unit.html">is_power_unit</a>&lt;T&gt;::value</code> to test the unit represents a power quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__voltage__unit.html">is_voltage_unit</a>&lt;T&gt;::value</code> to test the unit represents a voltage quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__capacitance__unit.html">is_capacitance_unit</a>&lt;T&gt;::value</code> to test the unit represents a capacitance quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__impedance__unit.html">is_impedance_unit</a>&lt;T&gt;::value</code> to test the unit represents a impedance quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__conductance__unit.html">is_conductance_unit</a>&lt;T&gt;::value</code> to test the unit represents a conductance quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__magnetic__flux__unit.html">is_magnetic_flux_unit</a>&lt;T&gt;::value</code> to test the unit represents a <a class="el" href="namespaceunits_1_1magnetic__flux.html" title="namespace for unit types and containers representing magnetic_flux values">magnetic_flux</a> quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__magnetic__field__strength__unit.html">is_magnetic_field_strength_unit</a>&lt;T&gt;::value</code> to test the unit represents a <a class="el" href="namespaceunits_1_1magnetic__field__strength.html" title="namespace for unit types and containers representing magnetic_field_strength values">magnetic_field_strength</a> quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__inductance__unit.html">is_inductance_unit</a>&lt;T&gt;::value</code> to test the unit represents a inductance quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__luminous__flux__unit.html">is_luminous_flux_unit</a>&lt;T&gt;::value</code> to test the unit represents a <a class="el" href="namespaceunits_1_1luminous__flux.html" title="namespace for unit types and containers representing luminous_flux values">luminous_flux</a> quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__illuminance__unit.html">is_illuminance_unit</a>&lt;T&gt;::value</code> to test the unit represents a illuminance quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__radioactivity__unit.html">is_radioactivity_unit</a>&lt;T&gt;::value</code> to test the unit represents a radioactivity quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__torque__unit.html">is_torque_unit</a>&lt;T&gt;::value</code> to test the unit represents a torque quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__area__unit.html">is_area_unit</a>&lt;T&gt;::value</code> to test the unit represents a area quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__volume__unit.html">is_volume_unit</a>&lt;T&gt;::value</code> to test the unit represents a volume quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__density__unit.html">is_density_unit</a>&lt;T&gt;::value</code> to test the unit represents a density quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__concentration__unit.html">is_concentration_unit</a>&lt;T&gt;::value</code> to test the unit represents a concentration quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__data__unit.html">is_data_unit</a>&lt;T&gt;::value</code> to test the unit represents a data quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test</td></tr>
  </table>
  </dd>
</dl>
<p>Inherits from <code>std::true_type</code> or <code>std::false_type</code>. Use <code><a class="el" href="structunits_1_1traits_1_1is__data__transfer__rate__unit.html">is_data_transfer_rate_unit</a>&lt;T&gt;::value</code> to test the unit represents a <a class="el" href="namespaceunits_1_1data__transfer__rate.html" title="namespace for unit types and containers representing data values">data_transfer_rate</a> quantity. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>one or more types to test </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Typedef Documentation</h2>
<a id="ae7756e0f6e8322f5c6150be2b871e544"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae7756e0f6e8322f5c6150be2b871e544">&#9670;&nbsp;</a></span>base_unit_of</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="namespaceunits_1_1traits.html#ae7756e0f6e8322f5c6150be2b871e544">units::traits::base_unit_of</a> = typedef typename units::detail::base_unit_of_impl&lt;U&gt;::type</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Trait which returns the <code><a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a></code> type that a unit is originally derived from. </p>
<p>Since units can be derived from other <code>unit</code> types in addition to <code><a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a></code> types, the <code>base_unit_type</code> typedef will not always be a <code><a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a></code> (or unit category). Since compatible </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Oct 3 2020 11:16:54 for Unit Conversion and Dimensional Analysis Library by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
